<template>
  <v-container>
    <v-row>
      <v-col
        class="px-0 pr-sm-3"
        cols="12"
        sm="6"
      >
        <v-text-field
          readonly
          :value="startDate | formatDate"
          :placeholder="$t('datesPlaceholderCta')"
          :label="$t('startDate', requiredFlag)"
          :rules="startDateRules"
          :append-icon="appendIcon"
          prepend-icon="mdi-calendar"
          @click="toggleCalendar"
          @click:append="toggleCalendar"
        />
      </v-col>
      <v-col
        class="px-0 pl-sm-3"
        cols="12"
        sm="6"
      >
        <v-text-field
          readonly
          :value="endDate | formatDate"
          :placeholder="$t('datesPlaceholderCta')"
          :label="$t('endDate', requiredFlag)"
          :rules="endDateRules"
          :append-icon="appendIcon"
          prepend-icon="mdi-calendar"
          @click="toggleCalendar"
          @click:append="toggleCalendar"
        />
      </v-col>
    </v-row>
    <v-row v-show="isToDisplayCalendar">
      <v-col class="px-0">
        <div
          class="calender-cta"
          :style="calendarCtaBackgroundColor"
        >
          {{ $t('calenderCta') }}
        </div>
        <v-date-picker
          v-bind="$attrs"
          :value="value"
          :locale="administrator.language"
          range
          no-title
          full-width
          elevation="3"
          v-on="$listeners"
          @input="$emit('input', $event)"
        />
      </v-col>
    </v-row>
  </v-container>
</template>

<script>
  import { get } from 'vuex-pathify'
  import DatesMixin from '@/mixins/date'
  import { required, minDate } from '@/lib/validators'

  export default {
    name: 'DatePickerRangeField',
    mixins: [DatesMixin],
    props: {
      value: Array,
      required: {
        type: Boolean,
        required: false,
        default: false,
      },
    },
    data () {
      return {
        dates: [],
        isToDisplayCalendar: false,
      }
    },
    computed: {
      administrator: get('auth/authUser'),
      calendarCtaBackgroundColor () {
        return { backgroundColor: this.$vuetify.theme.themes.light.primary }
      },
      requiredRule () {
        return this.required
          ? [required]
          : []
      },
      startDateRules () {
        return this.requiredRule
      },
      endDateRules () {
        return [...this.requiredRule, () => minDate(this.startDate)(this.endDate)]
      },
      requiredFlag () {
        return this.required
          ? { requiredFlag: '*' }
          : { requiredFlag: '' }
      },
      appendIcon () {
        return this.isToDisplayCalendar ? 'mdi-chevron-up' : 'mdi-chevron-down'
      },
      startDate () {
        return this.value[0]
      },
      endDate () {
        return this.value[1]
      },
    },
    created () {
      this.$emit('reset', this.reset)
    },
    methods: {
      toggleCalendar () {
        this.isToDisplayCalendar = !this.isToDisplayCalendar
      },
      reset () {
        this.isToDisplayCalendar = false
        this.$emit('input', [])
      },
    },
    i18n: {
      messages: {
        'pt-BR': {
          startDate: 'Data inicial{requiredFlag}',
          endDate: 'Data final{requiredFlag}',
          datesPlaceholderCta: 'Selecione a data pelo calendário.',
          calenderCta: 'Utilize o calendário para selecionar a data inicial e a data final.',
        },
        'en-US': {
          startDate: 'Initial date{requiredFlag}',
          endDate: 'End date{requiredFlag}',
          datesPlaceholderCta: 'Select the date from the calendar.',
          calenderCta: 'Use the calendar to select the start date and end date.',
        },
      },
    },
  }
</script>

<style lang="scss">
.calender-cta {
  padding: 12px;
  font-weight: 500;
  color: #FFFFFF;
  border-top-left-radius: 4px;
  border-top-right-radius: 4px;
}
</style>
